shader_type canvas_item;

uniform float tile_factor = 1.0;
uniform vec2 noise_factor = vec2(1.0,1.0);
uniform float aspect_ratio = 1.0;
uniform vec2 uv_offset_size = vec2(0.5,0.5);
uniform vec2 waves_size = vec2(0.005,0.005);
uniform float time_scale = 0.001;
uniform float snap_time = 0.2;
uniform sampler2D uv_offset_texture : hint_black;

float rand(vec2 co){
	return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

//float noise(vec2 p){
//	vec2 ip = floor(p);
//	vec2 u = fract(p);
//	u = u*u*(3.0-2.0*u);
//
//	float res = mix(
//		mix(rand(ip),rand(ip+vec2(1.0,0.0)),u.x),
//		mix(rand(ip+vec2(0.0,1.0)),rand(ip+vec2(1.0,1.0)),u.x),u.y);
//	return res*res;
//}

float snap(float x, float snap){
	return snap * floor((x/snap) + 0.5) ;
}

void fragment() {
	
	vec2 offset_texture_uvs = UV * uv_offset_size;
	vec2 noise = vec2(1.0,1.0);
	float time = snap(TIME, snap_time);
//	float time = TIME;
	noise.x = rand(cos(noise+ time))  * noise_factor.x ;
	noise.y = rand(sin(noise + time)) * noise_factor.y;
//	offset_texture_uvs.x = noise.x;
//	offset_texture_uvs.y = noise.y;
	offset_texture_uvs.r +=  cos(TIME * time_scale) + noise.x;
	offset_texture_uvs.g += sin(TIME * time_scale) + noise.y;
	

	vec2 texture_based_offset = texture(uv_offset_texture, offset_texture_uvs).rg;
	texture_based_offset = texture_based_offset * 2.0 - 1.0;

	vec2 adjusted_uv = UV * tile_factor;
	adjusted_uv.y *= aspect_ratio;
	
	COLOR = texture(TEXTURE, adjusted_uv + texture_based_offset * waves_size );
//	COLOR = vec4(texture_based_offset, UV);
}